#include "ManagedLasoProvider.h"

doublereal SmartMathLibrary::LasoPack::ManagedLasoProvider::ddot_(integer *n,
  doublereal *dx, integer *incx, doublereal *dy, integer *incy)
{
  /* System generated locals */
  integer i__1;
  doublereal ret_val;

  /* Local variables */
  static integer i__, m;
  static doublereal dtemp;
  static integer ix, iy, mp1;


  /*     FORMS THE DOT PRODUCT OF TWO VECTORS. */
  /*     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE. */
  /*     JACK DONGARRA, LINPACK, 3/11/78. */


  /* Parameter adjustments */
  --dy;
  --dx;

  /* Function Body */
  ret_val = 0.;
  dtemp = 0.;
  if (*n <= 0)
  {
    return ret_val;
  }
  if (*incx == 1 &&  *incy == 1)
  {
    goto L20;
  }

  /*        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS */
  /*          NOT EQUAL TO 1 */

  ix = 1;
  iy = 1;
  if (*incx < 0)
  {
    ix = ( - (*n) + 1) **incx + 1;
  }
  if (*incy < 0)
  {
    iy = ( - (*n) + 1) **incy + 1;
  }
  i__1 =  *n;
  for (i__ = 1; i__ <= i__1; ++i__)
  {
    dtemp += dx[ix] *dy[iy];
    ix +=  *incx;
    iy +=  *incy;
    /* L10: */
  }
  ret_val = dtemp;
  return ret_val;

  /*        CODE FOR BOTH INCREMENTS EQUAL TO 1 */


  /*        CLEAN-UP LOOP */

  L20: m =  *n % 5;
  if (m == 0)
  {
    goto L40;
  }
  i__1 = m;
  for (i__ = 1; i__ <= i__1; ++i__)
  {
    dtemp += dx[i__] *dy[i__];
    /* L30: */
  }
  if (*n < 5)
  {
    goto L60;
  }
  L40: mp1 = m + 1;
  i__1 =  *n;
  for (i__ = mp1; i__ <= i__1; i__ += 5)
  {
    dtemp = dtemp + dx[i__] *dy[i__] + dx[i__ + 1] *dy[i__ + 1] + dx[i__ + 2]
      *dy[i__ + 2] + dx[i__ + 3] *dy[i__ + 3] + dx[i__ + 4] *dy[i__ + 4];
    /* L50: */
  }
  L60: ret_val = dtemp;
  return ret_val;
} /* ddot_ */
