#include "ManagedLasoProvider.h"

 /* Subroutine */int SmartMathLibrary::LasoPack::ManagedLasoProvider::dlaeig_
   (integer *n, integer *nband, integer *nl, integer*nr, doublereal *a,
   doublereal *eigval, integer *lde, doublereal *eigvec, doublereal *bound,
   doublereal *atemp, doublereal *d__, doublereal *vtemp, doublereal *eps,
   doublereal *tmin, doublereal *tmax)
{
  /* System generated locals */
  integer a_dim1, a_offset, eigvec_dim1, eigvec_offset, i__1;
  doublereal d__1, d__2;

  /* Builtin functions */
  //double sqrt(doublereal);

  /* Local variables */
  static doublereal atol;
  static integer nval, i__, m;
  static doublereal artol;
  //extern /* Subroutine */ int dlabcm_(integer *, integer *, integer *, 
  // integer *, doublereal *, doublereal *, integer *, doublereal *, 
  // doublereal *, doublereal *, doublereal *, doublereal *, 
  // doublereal *, doublereal *);


  /*  THIS IS A SPECIALIZED VERSION OF THE SUBROUTINE BNDEIG TAILORED */
  /*  SPECIFICALLY FOR USE BY THE LASO PACKAGE. */


  /*  LOCAL VARIABLES */


  /*  FUNCTIONS CALLED */


  /*  SUBROUTINES CALLED */

  /*     DLABCM, DLABFC, DLAGER, DCOPY */

  /*  SET PARAMETERS */

  /* Parameter adjustments */
  a_dim1 =  *nband;
  a_offset = 1+a_dim1 * 1;
  a -= a_offset;
  --eigval;
  eigvec_dim1 =  *lde;
  eigvec_offset = 1+eigvec_dim1 * 1;
  eigvec -= eigvec_offset;
  bound -= 3;
  --atemp;
  --d__;
  --vtemp;

  /* Function Body */
  /* Computing MAX */
  d__1 =  *tmax, d__2 =  - (*tmin);
  atol = (doublereal)((real)(*n)) **eps * max(d__1, d__2);
  artol = atol / sqrt(*eps);
  nval =  *nr -  *nl + 1;

  /*   CHECK FOR SPECIAL CASE OF N = 1 */

  if (*n != 1)
  {
    goto L30;
  }
  eigval[1] = a[a_dim1 + 1];
  eigvec[eigvec_dim1 + 1] = 1.;
  return 0;

  /*   SET UP INITIAL EIGENVALUE BOUNDS */

  L30: m = nval + 1;
  i__1 = m;
  for (i__ = 2; i__ <= i__1; ++i__)
  {
    bound[(i__ << 1) + 1] =  *tmin;
    bound[(i__ << 1) + 2] =  *tmax;
    /* L50: */
  }
  bound[4] =  *tmax;
  bound[(nval + 2 << 1) + 1] =  *tmin;
  if (*nl == 1)
  {
    bound[4] =  *tmin;
  }
  if (*nr ==  *n)
  {
    bound[(nval + 2 << 1) + 1] =  *tmax;
  }

  /* L60: */
  dlabcm_(n, nband, nl, nr, &a[a_offset], &eigval[1], lde,
    &eigvec[eigvec_offset], &atol, &artol, &bound[3], &atemp[1], &d__[1],
    &vtemp[1]);
  return 0;
} /* dlaeig_ */
