#include "ManagedLasoProvider.h"

 /* Subroutine */int SmartMathLibrary::LasoPack::ManagedLasoProvider::scopy_
   (integer *n, real *sx, integer *incx, real *sy, integer *incy)
{
  /* System generated locals */
  integer i__1;

  /* Local variables */
  static integer i__, m, ix, iy, mp1;


  /*     COPIES A VECTOR, X, TO A VECTOR, Y. */
  /*     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO 1. */
  /*     JACK DONGARRA, LINPACK, 3/11/78. */


  /* Parameter adjustments */
  --sy;
  --sx;

  /* Function Body */
  if (*n <= 0)
  {
    return 0;
  }
  if (*incx == 1 &&  *incy == 1)
  {
    goto L20;
  }

  /*        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS */
  /*          NOT EQUAL TO 1 */

  ix = 1;
  iy = 1;
  if (*incx < 0)
  {
    ix = ( - (*n) + 1) **incx + 1;
  }
  if (*incy < 0)
  {
    iy = ( - (*n) + 1) **incy + 1;
  }
  i__1 =  *n;
  for (i__ = 1; i__ <= i__1; ++i__)
  {
    sy[iy] = sx[ix];
    ix +=  *incx;
    iy +=  *incy;
    /* L10: */
  }
  return 0;

  /*        CODE FOR BOTH INCREMENTS EQUAL TO 1 */


  /*        CLEAN-UP LOOP */

  L20: m =  *n % 7;
  if (m == 0)
  {
    goto L40;
  }
  i__1 = m;
  for (i__ = 1; i__ <= i__1; ++i__)
  {
    sy[i__] = sx[i__];
    /* L30: */
  }
  if (*n < 7)
  {
    return 0;
  }
  L40: mp1 = m + 1;
  i__1 =  *n;
  for (i__ = mp1; i__ <= i__1; i__ += 7)
  {
    sy[i__] = sx[i__];
    sy[i__ + 1] = sx[i__ + 1];
    sy[i__ + 2] = sx[i__ + 2];
    sy[i__ + 3] = sx[i__ + 3];
    sy[i__ + 4] = sx[i__ + 4];
    sy[i__ + 5] = sx[i__ + 5];
    sy[i__ + 6] = sx[i__ + 6];
    /* L50: */
  }
  return 0;
} /* scopy_ */
