#include "ManagedLasoProvider.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;

/*  VERSION 2   DOES NOT USE EISPACK */

/* ------------------------------------------------------------------ */

 /* Subroutine */int SmartMathLibrary::LasoPack::ManagedLasoProvider::silaso_(U_fp
   op, U_fp iovect, integer *n, real *xl, real*xr, integer *nfig, integer
   *nperm, integer *nmval, real *val, integer *nmvec, integer *maxvec, real
   *vec, integer *nblock, integer *maxop, integer *maxj, real *work, integer
   *ind, integer *ierr)
{
  /* System generated locals */
  integer vec_dim1, vec_offset, val_dim1, val_offset, i__1, i__2;
  real r__1;

  /* Local variables */
  static real temp;
  //extern real snrm2_(integer *, real *, integer *);
  static integer i__, m, nband;
  //extern /* Subroutine */ int siwla_(U_fp, U_fp, integer *, integer *, real 
  // *, real *, integer *, integer *, real *, integer *, integer *, 
  // real *, integer *, integer *, integer *, integer *, real *, real *
  // , real *, real *, real *, real *, real *, real *, real *, real *, 
  // real *, real *, real *, real *, integer *, logical *, real *, 
  // real *, real *, integer *);
  static integer i1, i2, i3, i4, i5, i6, i7, i8, i9;
  //extern /* Subroutine */ int scopy_(integer *, real *, integer *, real *, 
  // integer *);
  static integer i10, i11, i12, i13, np;
  static real deltal, deltar;
  //extern /* Subroutine */ int sippla_(U_fp, U_fp, integer *, real *, real *,
  //  integer *, integer *, integer *, integer *, real *, integer *, 
  // real *, integer *, real *, real *, real *, real *, real *, real *,
  //  real *, real *, logical *, real *, integer *);
  static logical raritz;
  //extern /* Subroutine */ int sortqr_(integer *, integer *, integer *, real 
  // *, real *), svsort_(integer *, real *, real *, integer *, real *, 
  // integer *, integer *, real *);
  static real eps;
  static integer nop;



  /* AUTHOR/IMPLEMENTER D.S.SCOTT-B.N.PARLETT/D.S.SCOTT */

  /* COMPUTER SCIENCES DEPARTMENT */
  /* UNIVERSITY OF TEXAS AT AUSTIN */
  /* AUSTIN, TX 78712 */

  /* VERSION 2 ORIGINATED APRIL 1982 */

  /* CURRENT VERSION  JUNE 1983 */

  /* SILASO FINDS ALL THE EIGENVALUES AND EIGENVECTORS OF A LARGE */
  /* SPARSE SYMMETRIC MATRIX OUTSIDE A USER DEFINED EXCLUDED INTERVAL. */
  /* THE SUBROUTINE SILASO IS PRIMARILY A DRIVER FOR SUBROUTINE SIWLA */
  /* WHICH IMPLEMENTS THE LANCZOS ALGORITHM WITH SELECTIVE */
  /* ORTHOGONALIZATION AND SUBROUTINE SIPPLA WHICH POST PROCESSES */
  /* THE OUTPUT OF SIWLA.  HOWEVER SILASO DOES CHECK FOR INCONSISTENCIES */
  /* IN THE CALLING PARAMETERS AND DOES PREPROCESS AND USER SUPPLIED */
  /* EIGENPAIRS. */


  /* ON INPUT */


  /*   OP   A USER SUPPLIED SUBROUTINE WITH CALLING SEQUENCE */
  /*     OP(N,M,P,Q).  P AND Q ARE N X M MATRICES AND Q IS */
  /*     RETURNED AS THE MATRIX TIMES P. */

  /*   IOVECT   A USER SUPPLIED SUBROUTINE WITH CALLING SEQUENCE */
  /*     IOVECT(N,M,Q,J,K).  Q IS AN N X M MATRIX.  IF K = 0 */
  /*     THE COLUMNS OF Q ARE STORED AS THE (J-M+1)TH THROUGH */
  /*     THE JTH LANCZOS VECTORS.  IF K = 1 THEN Q IS RETURNED */
  /*     AS THE (J-M+1)TH THROUGH THE JTH LANCZOS VECTORS.  SEE */
  /*     DOCUMENTATION FOR FURTHER DETAILS AND EXAMPLES. */

  /*   N   THE ORDER OF THE MATRIX. */

  /*   XL   THE LEFT ENDPOINT OF THE EXCLUDED INTERVAL. */

  /*   XR   THE RIGHT ENDPOINT OF THE EXCLUDED INTERVAL. */

  /*   NFIG   THE NUMBER OF DECIMAL DIGITS OF ACCURACY DESIRED IN THE */
  /*     EIGENVALUES.  NFIG MUST BE GREATER THAN OR EQUAL TO 1. */

  /*   NPERM   AN INTEGER VARIABLE WHICH SPECIFIES THE NUMBER OF USER */
  /*     SUPPLIED EIGENPAIRS.  IN MOST CASES NPERM WILL BE ZERO.  SEE */
  /*     DOCUMENTAION FOR FURTHER DETAILS OF USING NPERM GREATER */
  /*     THAN ZERO.  NPERM MUST NOT BE LESS THAN ZERO. */

  /*   NMVAL   THE ROW DIMENSION OF THE ARRAY VAL.  NMVAL MUST BE GREATER */
  /*     THAN OR EQUAL TO MAXVEC. */

  /*   VAL   A TWO DIMENSIONAL REAL ARRAY OF ROW */
  /*     DIMENSION NMVAL AND COLUMN DIMENSION AT LEAST 4.  IF NPERM */
  /*     IS GREATER THAN ZERO THEN CERTAIN INFORMATION MUST BE STORED */
  /*     IN VAL.  SEE DOCUMENTATION FOR DETAILS. */

  /*   NMVEC   THE ROW DIMENSION OF THE ARRAY VEC.  NMVEC MUST BE GREATER */
  /*     THAN OR EQUAL TO N. */

  /*   MAXVEC   THE MAXIMUM NUMBER OF EIGENPAIRS TO BE DETERMINED. */
  /*     MAXVEC MUST NOT EXCEED THE COLUMN DIMENSION OF THE ARRAY VEC. */

  /*   VEC   A TWO DIMENSIONAL REAL ARRAY OF ROW */
  /*     DIMENSION NMVEC AND COLUMN DIMENSION MAXVEC.  IF NPERM > 0 */
  /*     THEN THE FIRST NPERM COLUMNS OF VEC MUST CONTAIN */
  /*     THE USER SUPPLIED EIGENVECTORS. */

  /*   NBLOCK   THE BLOCK SIZE.  SEE DOCUMENTATION FOR CHOOSING */
  /*     AN APPROPRIATE VALUE FOR NBLOCK.  NBLOCK MUST BE GREATER */
  /*     THAN ZERO .AND. LESS THAN  MAXJ/6. */

  /*   MAXOP   AN UPPER BOUND ON THE NUMBER OF CALLS TO THE SUBROUTINE */
  /*     OP.  SILASO TERMINATES WHEN MAXOP IS EXCEEDED.  SEE */
  /*     DOCUMENTATION FOR GUIDELINES IN CHOOSING A VALUE FOR MAXOP. */

  /*   MAXJ   AN INDICATION OF THE AVAILABLE STORAGE (SEE WORK AND */
  /*     DOCUMENTATION ON IOVECT).  FOR THE FASTEST CONVERGENCE MAXJ */
  /*     SHOULD BE AS LARGE AS POSSIBLE, ALTHOUGH IT IS USELESS TO HAVE */
  /*     MAXJ LARGER THAN MAXOP*NBLOCK. */

  /*   WORK   A REAL ARRAY OF DIMENSION AT LEAST AS */
  /*     LARGE AS */

  /*     2*N*NBLOCK + MAXJ*(NBLOCK+1+MAXVEC+2) + 2*NBLOCK*NBLOCK + 3*MAXVEC */

  /*     + THE MAXIMUM OF */
  /*          N*NBLOCK */
  /*             AND */
  /*          MAXJ*(2*NBLOCK+2) + 2*MAXVEC + 8 + (2*NBLOCK+2)*(NBLOCK+1) */

  /*     THE FIRST N*NBLOCK ELEMENTS OF WORK MUST CONTAIN THE DESIRED */
  /*     STARTING VECTORS.  SEE DOCUMENTATION FOR GUIDELINES IN */
  /*     CHOOSING STARTING VECTORS. */

  /*   IND   AN INTEGER ARRAY OF DIMENSION AT LEAST 4*MAXVEC. */

  /*   IERR   AN INTEGER VARIABLE. */


  /* ON OUTPUT */


  /*   NPERM   THE NUMBER OF EIGENPAIRS NOW KNOWN. */

  /*   VEC   THE FIRST NPERM COLUMNS OF VEC CONTAIN THE EIGENVECTORS. */

  /*   VAL   THE FIRST COLUMN OF VAL CONTAINS THE CORRESPONDING */
  /*     EIGENVALUES.  THE SECOND COLUMN CONTAINS THE RESIDUAL NORMS OF */
  /*     THE EIGENPAIRS WHICH ARE BOUNDS ON THE ACCURACY OF THE EIGEN- */
  /*     VALUES.  THE THIRD COLUMN CONTAINS MORE REALISTIC ESTIMATES */
  /*     OF THE ACCURACY OF THE EIGENVALUES.  THE FOURTH COLUMN CONTAIN */
  /*     ESTIMATES OF THE ACCURACY OF THE EIGENVECTORS.  SEE */
  /*     DOCUMENTATION FOR FURTHER INFORMATION ON THESE QUANTITIES. */

  /*   WORK   IF EXECUTION IS TERMINATED BEFORE ALL THE DESIRED */
  /*     EIGENVALUES ARE FOUND (IERR = -2, -5, OR -6 MOD(10) ) THEN */
  /*     THE FIRST N*NBLOCK ELEMENTS OF WORK CONTAIN THE BEST VECTORS */
  /*     FOR RESTARTING THE ALGORITHM AND SILASO CAN BE IMMEDIATELY */
  /*     RECALLED TO CONTINUE WORKING ON THE PROBLEM. */

  /*   IND   IND(1) CONTAINS THE ACTUAL NUMBER OF CALLS TO OP.  ON SOME */
  /*     OCCASIONS THE NUMBER OF CALLS TO OP MAY BE SLIGHTLY LARGER */
  /*     THAN MAXOP. */

  /*   IERR   AN ERROR COMPLETION CODE.  THE NORMAL COMPLETION CODE IS */
  /*     ZERO.  SEE THE DOCUMENTATION FOR INTERPRETATIONS OF NON-ZERO */
  /*     COMPLETION CODES. */


  /* INTERNAL VARIABLES. */



  /* NOP   RETURNED FROM SIWLA AS THE NUMBER OF CALLS TO THE */
  /*   SUBROUTINE OP. */

  /* RARITZ   RETURNED FROM SIWLA AS .TRUE.  IF A FINAL RAYLEIGH-RITZ */
  /*   PROCEDURE IS NEEDED. */

  /* DELTAL   RETURNED FROM SIWLA AS THE EXCLUDED EIGENVALUE CLOSEST */
  /*   TO XL. */

  /* DELTAR   RETURNED FROM SIWLA AS THE EXCLUDED EIGENVALUE CLOSEST */
  /*   TO XR. */

  /* SIPPLA   A SUBROUTINE FOR POST-PROCESSING THE EIGENVECTORS COMPUTED */
  /*   BY SIWLA. */

  /* SIWLA   A SUBROUTINE FOR IMPLEMENTING THE LANCZOS ALGORITHM */
  /*   WITH SELECTIVE ORTHOGONALIZATION. */

  /* SMVPC   A SUBROUTINE FOR COMPUTING THE RESIDUAL NORM AND */
  /*   ORTHOGONALITY COEFFICIENT OF A GIVEN RITZ VECTOR. */

  /* SORTQR   A SUBROUTINE FOR ORTHONORMALIZING A BLOCK OF VECTORS */
  /*   USING HOUSEHOLDER REFLECTIONS. */

  /* SAXPY,SCOPY,SDOT,SNRM2,SSCAL,SSWAP   A SUBSET OF THE BASIC LINEAR */
  /*   ALGEBRA SUBPROGRAMS USED FOR VECTOR MANIPULATION. */

  /* SLAEIG, SLABCM, SLABFC, SLAGER  USED FOR BAND EIGENVALUE PROBLEMS */

  /* SLARAN  SUBROUTINE WHICH RETURNS RANDOM VECTORS */

  /* ------------------------------------------------------------------ */

  /* THIS SECTION CHECKS FOR INCONSISTENCY IN THE INPUT PARAMETERS. */

  /* Parameter adjustments */
  val_dim1 =  *nmval;
  val_offset = 1+val_dim1 * 1;
  val -= val_offset;
  vec_dim1 =  *nmvec;
  vec_offset = 1+vec_dim1 * 1;
  vec -= vec_offset;
  --work;
  --ind;

  /* Function Body */
  ind[1] = 0;
  *ierr = 0;

  if (*n <  *nblock * 6)
  {
    *ierr = 1;
  }
  if (*nfig <= 0)
  {
    *ierr += 2;
  }
  if (*nmvec <  *n)
  {
    *ierr += 4;
  }
  if (*nperm < 0)
  {
    *ierr += 8;
  }
  if (*maxj <  *nblock * 6)
  {
    *ierr += 16;
  }
  if (*maxvec <  *nperm)
  {
    *ierr += 32;
  }
  if (*maxvec >  *nmval)
  {
    *ierr += 64;
  }
  if (*maxvec >  *maxop)
  {
    *ierr += 128;
  }
  if (*xl >  *xr)
  {
    *ierr += 256;
  }
  if (*nblock < 1)
  {
    *ierr += 512;
  }
  if (*ierr != 0)
  {
    return 0;
  }

  /* ------------------------------------------------------------------ */

  /* THIS SECTION SORTS AND ORTHONORMALIZES THE USER SUPPLIED VECTORS. */
  /* IF A USER SUPPLIED VECTOR IS ZERO OR IF SIGNIFICANT CANCELLATION */
  /* OCCURS IN THE ORTHOGONALIZATION PROCESS THEN IERR IS SET TO  -1 */
  /* AND SILASO TERMINATES.  IF A USER SUPPLIED EIGENVALUE LIES INSIDE */
  /* THE EXCLUDED INTERVAL THEN IERR IS SET TO  -4 AND SILASO TERMINATES. */

  if (*nperm == 0)
  {
    goto L100;
  }

  /* THIS SORTS THE USER SUPPLIED VALUES AND VECTORS. */

  svsort_(nperm, &val[val_offset], &val[(val_dim1 << 1) + 1], &c__0, &temp,
    nmvec, n, &vec[vec_offset]);

  /* THIS STORES THE NORMS OF THE VECTORS FOR LATER COMPARISON. */
  /* IT ALSO INSURES THAT THE REIDUAL NORMS ARE POSITIVE. */

  i__1 =  *nperm;
  for (i__ = 1; i__ <= i__1; ++i__)
  {
    val[i__ + (val_dim1 << 1)] = (r__1 = val[i__ + (val_dim1 << 1)], abs(r__1));
    val[i__ + val_dim1 * 3] = snrm2_(n, &vec[i__ *vec_dim1 + 1], &c__1);
    /* L40: */
  }

  /* THIS CHECKS FOR VALUES OUT OF RANGE */

  i__1 =  *nperm;
  for (i__ = 1; i__ <= i__1; ++i__)
  {
    if (val[i__ + val_dim1] <=  *xl || val[i__ + val_dim1] >=  *xr)
    {
      goto L50;
    }
    *ierr =  - 4;
    return 0;

    L50: ;
  }

  /* THIS ORTHONORMALIZES THE VECTORS */

  m =  *n **nblock + 1;
  sortqr_(nmvec, n, nperm, &vec[vec_offset], &work[m]);
  m =  *n **nblock -  *nperm;
  i__1 =  *nperm;
  for (i__ = 1; i__ <= i__1; ++i__)
  {
    m = m +  *nperm + 1;
    if ((r__1 = work[m], abs(r__1)) > val[i__ + val_dim1 * 3]*(float).9)
    {
      goto L60;
    }
    *ierr =  - 1;
    return 0;

    L60: ;
  }

  /* THIS COPIES THE RESIDUAL NORMS INTO THE CORRECT LOCATIONS IN */
  /* THE ARRAY WORK FOR LATER REFERENCE IN SIWLA. */

  m = (*n << 1) **nblock + 1;
  scopy_(nperm, &val[(val_dim1 << 1) + 1], &c__1, &work[m], &c__1);

  /* THIS SETS EPS TO AN APPROXIMATION OF THE MACHINE PRECISION */

  /* ***THIS SHOULD BE REPLACED BY AN ASSIGNMENT STATEMENT */
  /* ***IN A PRODUCTION CODE */

  L100: eps = (float)1.;
  for (i__ = 1; i__ <= 1000; ++i__)
  {
    eps *= (float).5;
    temp = eps + (float)1.;
    if (temp == (float)1.)
    {
      goto L120;
    }
    /* L110: */
  }

  /* ------------------------------------------------------------------ */

  /* THIS SECTION CALLS SIWLA WHICH IMPLEMENTS THE LANCZOS ALGORITHM */
  /* WITH SELECTIVE ORTHOGONALIZATION. */

  L120: nband =  *nblock + 1;
  i1 =  *n **nblock + 1;
  i2 = i1 +  *n **nblock;
  i3 = i2 +  *maxvec;
  i4 = i3 +  *maxvec;
  i5 = i4 +  *maxvec;
  i6 = i5 +  *maxj * nband;
  i7 = i6 +  *nblock **nblock;
  i8 = i7 +  *nblock **nblock;
  i9 = i8 +  *maxj *(*maxvec + 2);
  i10 = i9 +  *nblock;
  i11 = i10 + (*maxvec << 1) + 8;
  i12 = i11 +  *maxj *((*nblock << 1) + 1);
  i13 = i12 +  *maxj;
  siwla_((U_fp)op, (U_fp)iovect, n, &nband, xl, xr, nfig, nperm,
    &val[val_offset], nmvec, maxvec, &vec[vec_offset], nblock, maxop, maxj, 
    &nop, &work[1], &work[i1], &work[i2], &work[i3], &work[i4], &work[i5],
    &work[i6], &work[i7], &work[i8], &work[i9], &work[i10],  &work[i11],
    &work[i12], &work[i13], &ind[1], &raritz, &deltal, &deltar, &eps, ierr);

  /* ------------------------------------------------------------------ */

  /* THIS SECTION CALLS SIPPLA (THE POST PROCESSOR).  NP IS USED */
  /* TO DIMENSION AN ARRAY IN SIPPLA.  IT IS NEEDED TO LEGALIZE */
  /* CHANGING THE VALUE OF NPERM, WHICH MAY OCCUR IN SIPPLA. */

  if (*nperm == 0)
  {
    goto L130;
  }
  i1 =  *n **nblock + 1;
  i2 = i1 +  *nperm **nperm;
  i3 = i2 +  *nperm **nperm;
  /* Computing MAX */
  i__1 =  *n **nblock, i__2 = (*nperm << 1) **nperm;
  i4 = i3 + max(i__1, i__2);
  i5 = i4 +  *n **nblock;
  i6 = i5 + (*nperm << 1) + 4;
  np =  *nperm;
  sippla_((U_fp)op, (U_fp)iovect, n, xl, xr, &np, nperm, &nop, nmval,
    &val[val_offset], nmvec, &vec[vec_offset], nblock, &work[i1], &work[i2],
    &work[i3], &work[i4], &work[i5], &work[i6], &deltal, &deltar, &raritz, &eps,
    ierr);

  L130: ind[1] = nop;
  return 0;
} /* silaso_ */
