#include "ManagedLasoProvider.h"

/* Table of constant values */

static integer c__1 = 1;

 /* Subroutine */int SmartMathLibrary::LasoPack::ManagedLasoProvider::sortqr_
   (integer *nz, integer *n, integer *nblock, real *z__, real *b)
{
  /* System generated locals */
  integer z_dim1, z_offset, b_dim1, b_offset, i__1, i__2;
  real r__1;

  /* Builtin functions */
  //double r_sign(real *, real *);

  /* Local variables */
  static real temp;
  /*extern real sdot_(integer *, real *, integer *, real *, integer *), 
  snrm2_(integer *, real *, integer *);*/
  static integer i__, j, k, m;
  static real sigma;
  //extern /* Subroutine */ int sscal_(integer *, real *, real *, integer *), 
  // saxpy_(integer *, real *, real *, integer *, real *, integer *);
  static integer length;
  static real tau;



  /* THIS SUBROUTINE COMPUTES THE QR FACTORIZATION OF THE N X NBLOCK */
  /* MATRIX Z.  Q IS FORMED IN PLACE AND RETURNED IN Z.  R IS */
  /* RETURNED IN B. */


  /* THIS SECTION REDUCES Z TO TRIANGULAR FORM. */

  /* Parameter adjustments */
  z_dim1 =  *nz;
  z_offset = 1+z_dim1 * 1;
  z__ -= z_offset;
  b_dim1 =  *nblock;
  b_offset = 1+b_dim1 * 1;
  b -= b_offset;

  /* Function Body */
  i__1 =  *nblock;
  for (i__ = 1; i__ <= i__1; ++i__)
  {

    /* THIS FORMS THE ITH REFLECTION. */

    length =  *n - i__ + 1;
    r__1 = snrm2_(&length, &z__[i__ + i__ * z_dim1], &c__1);
    sigma = r_sign(&r__1, &z__[i__ + i__ * z_dim1]);
    b[i__ + i__ * b_dim1] =  - sigma;
    z__[i__ + i__ * z_dim1] += sigma;
    tau = sigma * z__[i__ + i__ * z_dim1];
    if (i__ ==  *nblock)
    {
      goto L30;
    }
    j = i__ + 1;

    /* THIS APPLIES THE ROTATION TO THE REST OF THE COLUMNS. */

    i__2 =  *nblock;
    for (k = j; k <= i__2; ++k)
    {
      if (tau == (float)0.)
      {
        goto L10;
      }
      temp =  - sdot_(&length, &z__[i__ + i__ * z_dim1], &c__1, &z__[i__ + k *
        z_dim1], &c__1) / tau;
      saxpy_(&length, &temp, &z__[i__ + i__ * z_dim1], &c__1, &z__[i__ + k *
        z_dim1], &c__1);
      L10: b[i__ + k * b_dim1] = z__[i__ + k * z_dim1];
      z__[i__ + k * z_dim1] = (float)0.;
      /* L20: */
    }
    L30: ;
  }

  /* THIS ACCUMULATES THE REFLECTIONS IN REVERSE ORDER. */

  i__1 =  *nblock;
  for (m = 1; m <= i__1; ++m)
  {

    /* THIS RECREATES THE ITH = NBLOCK-M+1)TH REFLECTION. */

    i__ =  *nblock + 1-m;
    sigma =  - b[i__ + i__ * b_dim1];
    tau = z__[i__ + i__ * z_dim1] *sigma;
    if (tau == (float)0.)
    {
      goto L60;
    }
    length =  *n -  *nblock + m;
    if (i__ ==  *nblock)
    {
      goto L50;
    }
    j = i__ + 1;

    /* THIS APPLIES IT TO THE LATER COLUMNS. */

    i__2 =  *nblock;
    for (k = j; k <= i__2; ++k)
    {
      temp =  - sdot_(&length, &z__[i__ + i__ * z_dim1], &c__1, &z__[i__ + k *
        z_dim1], &c__1) / tau;
      saxpy_(&length, &temp, &z__[i__ + i__ * z_dim1], &c__1, &z__[i__ + k *
        z_dim1], &c__1);
      /* L40: */
    }
    L50: r__1 = (float) - 1. / sigma;
    sscal_(&length, &r__1, &z__[i__ + i__ * z_dim1], &c__1);
    L60: z__[i__ + i__ * z_dim1] += (float)1.;
    /* L70: */
  }
  return 0;
} /* sortqr_ */
