#include "ManagedLasoProvider.h"

 /* Subroutine */int SmartMathLibrary::LasoPack::ManagedLasoProvider::sscal_
   (integer *n, real *sa, real *sx, integer *incx)
{
  /* System generated locals */
  integer i__1, i__2;

  /* Local variables */
  static integer i__, m, nincx, mp1;


  /*     SCALES A VECTOR BY A CONSTANT. */
  /*     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO 1. */
  /*     JACK DONGARRA, LINPACK, 3/11/78. */


  /* Parameter adjustments */
  --sx;

  /* Function Body */
  if (*n <= 0)
  {
    return 0;
  }
  if (*incx == 1)
  {
    goto L20;
  }

  /*        CODE FOR INCREMENT NOT EQUAL TO 1 */

  nincx =  *n **incx;
  i__1 = nincx;
  i__2 =  *incx;
  for (i__ = 1; i__2 < 0 ? i__ >= i__1: i__ <= i__1; i__ += i__2)
  {
    sx[i__] =  *sa * sx[i__];
    /* L10: */
  }
  return 0;

  /*        CODE FOR INCREMENT EQUAL TO 1 */


  /*        CLEAN-UP LOOP */

  L20: m =  *n % 5;
  if (m == 0)
  {
    goto L40;
  }
  i__2 = m;
  for (i__ = 1; i__ <= i__2; ++i__)
  {
    sx[i__] =  *sa * sx[i__];
    /* L30: */
  }
  if (*n < 5)
  {
    return 0;
  }
  L40: mp1 = m + 1;
  i__2 =  *n;
  for (i__ = mp1; i__ <= i__2; i__ += 5)
  {
    sx[i__] =  *sa * sx[i__];
    sx[i__ + 1] =  *sa * sx[i__ + 1];
    sx[i__ + 2] =  *sa * sx[i__ + 2];
    sx[i__ + 3] =  *sa * sx[i__ + 3];
    sx[i__ + 4] =  *sa * sx[i__ + 4];
    /* L50: */
  }
  return 0;
} /* sscal_ */
