﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary 
{
    /// <summary>
    /// This class provides grouping functionalities for all kinds of complex polynomial 
    /// implementations.
    /// </summary>
    [Serializable]
    public abstract class AbstractComplexPolynomial : AbstractPolynomial
    {
        /// <summary>
        /// Solves the polynomial at the specified position x.
        /// </summary>
        /// <param name="x">The value for evaluation.</param>
        /// <returns>The result f(x) at the specified position x.</returns>
        public abstract ComplexNumber SolveAt(ComplexNumber x);
    }
}