﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary
{
    /// <summary>
    /// This class provides grouping functionalities for all kinds of real polynomial 
    /// implementations.
    /// </summary>
    [Serializable]
    public abstract class AbstractRealPolynomial : AbstractPolynomial
    {
        /// <summary>
        /// Solves the polynomial at the specified position x.
        /// </summary>
        /// <param name="x">The specified position x.</param>
        /// <returns>The result f(x) at the specified position x.</returns>
        public abstract double SolveAt(double x);
    }
}