﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary
{
    /// <summary>
    /// This abstract class groups all implementations of splines.
    /// </summary>
    [Serializable]
    public abstract class AbstractSpline
    {
        /// <summary>
        /// Calculates the value of the spline at the specified position x.
        /// </summary>
        /// <param name="x">The specified position x.</param>
        /// <returns>The s(x) of the spline.</returns>
        public abstract double SolveAt(double x);
    }
}