﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary
{
    /// <summary>
    /// This class represents a band matrix.
    /// </summary>
    [Serializable]
    public class BandMatrix : Matrix
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BandMatrix"/> class.
        /// </summary>
        /// <param name="rows">The number of matrix rows.</param>
        /// <param name="columns">The number of matrix columns.</param>
        public BandMatrix(int rows, int columns)
            : base(rows, columns)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BandMatrix"/> class.
        /// </summary>
        /// <param name="matrix">The values of the matrix.</param>
        public BandMatrix(double[,] matrix)
            : base(matrix)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BandMatrix"/> class.
        /// </summary>
        /// <param name="matrix">The matrix to clone.</param>
        public BandMatrix(Matrix matrix)
            : base(matrix)
        {
        }
    }
}