﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Blas
{
    /// <summary>
    /// Represents the possible values specifying the part of the storage array where the elements 
    /// of a triangular or symmetrical matrix are stored. 
    /// </summary>
    public enum MatrixTriangleMode
    {
        /// <summary>
        /// The matrix is lower triangular, or the matrix elements are stored in the lower triangular 
        /// portion of the storage array. 
        /// </summary>
        Lower = 0,
        /// <summary>
        /// The matrix is upper triangular, or the matrix elements are stored in the upper triangular 
        /// portion of the storage array. 
        /// </summary>
        Upper = 1
    }
}