﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Blas
{
    /// <summary>
    /// Represents the possible values of an operation to be performed on a Matrix before it is multiplied. 
    /// </summary>
    public enum TransposeOperation
    {
        /// <summary>
        /// The conjugate of the Matrix is multiplied. For real matrices, this is the same as None. 
        /// </summary>
        Conjugate = 0,
        /// <summary>
        /// The conjugate transpose of the Matrix  is multiplied. For real matrices, this is the same as Transpose. 
        /// </summary>
        ConjugateTranspose = 1,
        /// <summary>
        /// No operation is performed. The Matrix  is multiplied 'as is.' 
        /// </summary>
        None = 2,
        /// <summary>
        /// The transpose of the Matrix multiplied. 
        /// </summary>
        Transpose = 3
    }
}