﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace SmartMathLibrary
{
    /// <summary>
    /// This class is a special exception, that handles convergence problems during a calculation.
    /// </summary>
    [Serializable]
    public class ConvergenceException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ConvergenceException"/> class.
        /// </summary>
        public ConvergenceException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ConvergenceException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        public ConvergenceException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ConvergenceException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public ConvergenceException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ConvergenceException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected ConvergenceException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}