﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.DataMining.ClusterAnalysis
{
    /// <summary>
    /// This class represents an abstract layer for all cluster analyser classes.
    /// </summary>
    [Serializable]
    public abstract class AbstractClusterAnalyser
    {
        /// <summary>
        /// Executes the cluster analysis.
        /// </summary>
        public abstract void ExecuteClusterAnalysis();

        /// <summary>
        /// Executes the cluster analysis.
        /// </summary>
        /// <param name="precision">The precision of the cluster analysis.</param>
        public abstract void ExecuteClusterAnalysis(double precision);
    }
}