namespace SmartMathLibrary.DataMining.ClusterAnalysis
{
    /// <summary>
    /// Interface to implement a SelfOrganisingMapResultItem class.
    /// </summary>
    public interface ISelfOrganisingMapResultItem
    {
        /// <summary>
        /// Gets or sets the x position of the result item.
        /// </summary>
        /// <value>The x position of the result item.</value>
        double X { get; set; }

        /// <summary>
        /// Gets or sets the y position of the result item.
        /// </summary>
        /// <value>The y position of the result item.</value>
        double Y { get; set; }

        /// <summary>
        /// Gets or sets the reference object of the item.
        /// </summary>
        /// <value>The reference object of the item.</value>
        object ReferenceObject { get; set; }
    }
}