namespace SmartMathLibrary.DataMining
{
    /// <summary>
    /// Interface to implement a PrincipalComponentAnalysisResultItem class.
    /// </summary>
    public interface IPrincipalComponentAnalysisResultItem
    {
        /// <summary>
        /// Gets or sets the column index of the analysis result item.
        /// </summary>
        /// <value>The column index of the analysis result item.</value>
        int ColumnIndex { get; set; }

        /// <summary>
        /// Gets or sets the eigenvalue of the analysis result item.
        /// </summary>
        /// <value>The eigenvalue of the analysis result item.</value>
        double EigenValue { get; set; }

        /// <summary>
        /// Gets or sets the total variance of the column.
        /// </summary>
        /// <value>The total variance of the column.</value>
        double TotalVariance { get; set; }

        /// <summary>
        /// Gets or sets the total cumulative percentage of the column.
        /// </summary>
        /// <value>The total cumulative percentage of the column.</value>
        double CumulativePercentage { get; set; }
    }
}