﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace SmartMathLibrary
{
    /// <summary>
    /// This exception should be thrown if the current domain does not allow a 
    /// specified value. 
    /// </summary>
    [Serializable]
    public class DomainNotDefinedException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DomainNotDefinedException"/> class.
        /// </summary>
        public DomainNotDefinedException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DomainNotDefinedException"/> class.
        /// </summary>
        /// <param name="message">The error message.</param>
        public DomainNotDefinedException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DomainNotDefinedException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public DomainNotDefinedException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DomainNotDefinedException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected DomainNotDefinedException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}