﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.ExpressionEvaluation
{
    /// <summary>
    /// This class represents an abstract layer for all expression evaluators.
    /// </summary>
    [Serializable]
    public abstract class AbstractExpressionEvaluator
    {
        /// <summary>
        /// Evaluates the specified mathematical term.
        /// </summary>
        /// <returns>The result of the mathematical term.</returns>
        public abstract double Evaluate();
    }
}