﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace SmartMathLibrary.ExpressionEvaluation
{
    /// <summary>
    /// This class represents an NotationSyntaxErrorException, which will be thrown the 
    /// expression to eval has a syntax errror.
    /// </summary>
    [Serializable]
    public class NotationSyntaxErrorException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="NotationSyntaxErrorException"/> class.
        /// </summary>
        public NotationSyntaxErrorException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotationSyntaxErrorException"/> class.
        /// </summary>
        /// <param name="message">The error message which the exception includes.</param>
        public NotationSyntaxErrorException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotationSyntaxErrorException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public NotationSyntaxErrorException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotationSyntaxErrorException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected NotationSyntaxErrorException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}