﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace SmartMathLibrary.ExpressionEvaluation
{
    /// <summary>
    /// This class represents an OperatorNotSupportedException, which will be thrown the 
    /// specified operator will not be supported.
    /// </summary>
    [Serializable]
    public class OperatorNotSupportedException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OperatorNotSupportedException"/> class.
        /// </summary>
        public OperatorNotSupportedException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="OperatorNotSupportedException"/> class.
        /// </summary>
        /// <param name="message">The error message which the exception includes.</param>
        public OperatorNotSupportedException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="OperatorNotSupportedException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public OperatorNotSupportedException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="OperatorNotSupportedException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected OperatorNotSupportedException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}