﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace SmartMathLibrary.ExpressionEvaluation
{
    /// <summary>
    /// This class represents an TokenDoesNotExistException, which will be thrown the 
    /// requested token does not exist.
    /// </summary>
    [Serializable]
    public class TokenDoesNotExistException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TokenDoesNotExistException"/> class.
        /// </summary>
        public TokenDoesNotExistException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="TokenDoesNotExistException"/> class.
        /// </summary>
        /// <param name="message">The error message which the exception includes.</param>
        public TokenDoesNotExistException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="TokenDoesNotExistException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public TokenDoesNotExistException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="TokenDoesNotExistException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected TokenDoesNotExistException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}