﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.FFTPack
{
    /// <summary>
    /// Construct a 1-D complex data sequence.
    /// </summary>
    [Serializable]
    public class Complex1D
    {
        /// <summary>
        /// The real number part of the sequence.
        /// </summary>
        private double[] x;

        /// <summary>
        /// The imaginary number part of the sequence.
        /// </summary>
        private double[] y;

        /// <summary>
        /// Initializes a new instance of the <see cref="Complex1D"/> class.
        /// </summary>
        /// <param name="x">The real number part of the sequence.</param>
        /// <param name="y">The imaginary number part of the sequence.</param>
        public Complex1D(double[] x, double[] y)
        {
            this.x = x;
            this.y = y;
        }

        /// <summary>
        /// Gets or sets the real number part of the sequence.
        /// </summary>
        /// <value>The real number part of the sequence.</value>
        public double[] X
        {
            get { return x; }
            set { x = value; }
        }

        /// <summary>
        /// Gets or sets the imaginary number part of the sequence.
        /// </summary>
        /// <value>The imaginary number part of the sequence.</value>
        public double[] Y
        {
            get { return y; }
            set { y = value; }
        }
    }
}