using System;

namespace SmartMathLibrary.Filters.BloomFilter
{
    /// <summary>
    /// Interface to implement an MultibleBloomFilter object class.
    /// </summary>
    public interface IMultipleBloomFilter
    {
        /// <summary>
        /// Gets the hash codes, which will be used by the BloomFilter.
        /// </summary>
        /// <param name="instanceNumber">The instance number, which describes the index of the algorithm for 
        /// generating the hash value.</param>
        /// <returns>
        /// The hash codes, which will be used by the BloomFilter
        /// </returns>
        UInt64 GetBloomHashCode(int instanceNumber);
    }
}