namespace SmartMathLibrary
{
    /// <summary>
    /// Interface which represents a complex function.
    /// </summary>
    public interface IComplexFunction
    {
        /// <summary>
        /// Calculates the complex function at the specified value x.
        /// </summary>
        /// <param name="x">The specified value x.</param>
        /// <returns>The result of the complex function at the specified value x.</returns>
        ComplexNumber SolveAt(ComplexNumber x);
    }
}