namespace SmartMathLibrary
{
    /// <summary>
    /// Interface to implement a HardBivariateComplexFunction class.
    /// </summary>
    public interface IHardBivariateComplexFunction
    {
        /// <summary>
        /// Calculates the function at the specified values a and b.
        /// </summary>
        /// <param name="a">The first parameter of the function.</param>
        /// <param name="b">The second parameter of the function.</param>
        /// <returns>
        /// The result of the function at the specified values a and b.
        /// </returns>
        ComplexNumber SolveAt(ComplexNumber a, ComplexNumber b);
    }
}