namespace SmartMathLibrary
{
    /// <summary>
    /// Interface to implement a HardBivariateRealFunction class.
    /// </summary>
    public interface IHardBivariateRealFunction
    {
        /// <summary>
        /// Calculates the function at the specified values a and b.
        /// </summary>
        /// <param name="a">The first parameter of the function.</param>
        /// <param name="b">The second parameter of the function.</param>
        /// <returns>
        /// The result of the function at the specified values a and b.
        /// </returns>
        double SolveAt(double a, double b);
    }
}