namespace SmartMathLibrary
{
    /// <summary>
    /// Interface to implement a HardMultivariateRealFunction class.
    /// </summary>
    public interface IHardMultivariateRealFunction
    {
        /// <summary>
        /// Calculates the function at the specified vector.
        /// </summary>
        /// <param name="vector">The input values for the function in form of a vector.</param>
        /// <returns>
        /// The result of the function at the specified vector.
        /// </returns>
        double SolveAt(GeneralVector vector);
    }
}