namespace SmartMathLibrary
{
    /// <summary>
    /// Interface to implement a HardTrivariateComplexFunction class.
    /// </summary>
    public interface IHardTrivariateComplexFunction
    {
        /// <summary>
        /// Calculates the function at the specified values a, b and c.
        /// </summary>
        /// <param name="a">The first parameter of the function.</param>
        /// <param name="b">The second parameter of the function.</param>
        /// <param name="c">The third parameter of the function.</param>
        /// <returns>
        /// The result of the function at the specified values a, b and c.
        /// </returns>
        ComplexNumber SolveAt(ComplexNumber a, ComplexNumber b, ComplexNumber c);
    }
}