namespace SmartMathLibrary
{
    /// <summary>
    /// Interface to implement a MultidimensionalTaylorSeries class.
    /// </summary>
    public interface IMultidimensionalTaylorSeries
    {
        /// <summary>
        /// Solves the specified Taylor series at the specified position x.
        /// </summary>
        /// <param name="x">The specified position x.</param>
        /// <returns>The series value at the specified position x.</returns>
        double SolveAt(GeneralVector x);
    }
}