namespace SmartMathLibrary
{
    /// <summary>
    /// Interface to implement a PolarCoordinate class.
    /// </summary>
    public interface IPolarCoordinate
    {
        /// <summary>
        /// Gets or sets the radius.
        /// </summary>
        /// <value>The radius.</value>
        double Radius { get; set; }

        /// <summary>
        /// Gets or sets the azimuth angle in radians.
        /// </summary>
        /// <value>The azimuth angle.</value>
        double AzimuthAngle { get; set; }

        /// <summary>
        /// Gets or sets the polar angle in radians.
        /// </summary>
        /// <value>The polar angle.</value>
        double PolarAngle { get; set; }
    }
}