namespace SmartMathLibrary
{
    /// <summary>
    /// Interface which represents a real function.
    /// </summary>
    public interface IRealFunction
    {
        /// <summary>
        /// Calculates the function at the specified value x.
        /// </summary>
        /// <param name="x">The specified value x.</param>
        /// <returns>The result of the function at the specified value x.</returns>
        double SolveAt(double x);
    }
}