namespace SmartMathLibrary
{
    /// <summary>
    /// Interface to implement a TaylorSeries class.
    /// </summary>
    public interface ITaylorSeries
    {
        /// <summary>
        /// Solves the Taylor series at the specified position x.
        /// </summary>
        /// <param name="x">The specified position x.</param>
        /// <returns>The value p(x) for the specified x value.</returns>
        double SolveAt(double x);
    }
}