namespace SmartMathLibrary
{
    /// <summary>
    /// Interface to implement a TaylorSeriesDevelopment class.
    /// </summary>
    public interface ITaylorSeriesDevelopment
    {
        /// <summary>
        /// Develops the Taylor series.
        /// </summary>
        /// <param name="a">The function about point of the series.</param>
        /// <param name="n">The maximum derivative, which should be used to develop the series.</param>
        /// <returns>The developed Taylor series.</returns>
        TaylorSeries DevelopSeries(double a, int n);
    }
}