﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace SmartMathLibrary
{
    /// <summary>
    /// This class represents an IllegalPositionException, which will be thrown if
    /// the called position if a matrix does not exist.
    /// </summary>
    [Serializable]
    public class IllegalPositionException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="IllegalPositionException"/> class.
        /// </summary>
        public IllegalPositionException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="IllegalPositionException"/> class.
        /// </summary>
        /// <param name="message">The error message which the exception includes.</param>
        public IllegalPositionException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="IllegalPositionException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public IllegalPositionException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="IllegalPositionException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The serialization info.</param>
        /// <param name="streamingContext">The streaming context.</param>
        protected IllegalPositionException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}