﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Interfaces.Web.Twitter
{
    /// <summary>
    /// This class describes the connection information, which twitter requires.
    /// </summary>
    [Serializable]
    public class Connection : IConnection
    {
        /// <summary>
        /// The username of the twitter account.
        /// </summary>
        private string userName;

        /// <summary>
        /// The username of the password account.
        /// </summary>
        private string password;

        /// <summary>
        /// Initializes a new instance of the <see cref="Connection"/> class.
        /// </summary>
        /// <param name="userName">The username of the account.</param>
        /// <param name="password">The password of the account.</param>
        public Connection(string userName, string password)
        {
            this.userName = userName;
            this.password = password;
        }

        /// <summary>
        /// Gets or sets the username of the twitter account.
        /// </summary>
        /// <value>The username of the twitter account.</value>
        public string UserName
        {
            get { return userName; }
            set { userName = value; }
        }

        /// <summary>
        /// Gets or sets the username of the password account.
        /// </summary>
        /// <value>The username of the password account.</value>
        public string Password
        {
            get { return password; }
            set { password = value; }
        }
    }
}