﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Interfaces.Web.Twitter 
{
    /// <summary>
    /// This class represents a twitter friend.
    /// </summary>
    [Serializable]
    public class Friend : User
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Friend"/> class.
        /// </summary>
        public Friend()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Friend"/> class.
        /// </summary>
        /// <param name="id">The id information of the user.</param>
        /// <param name="name">The name information of the user.</param>
        /// <param name="screenName">The screen name information of the user.</param>
        /// <param name="location">The location information of the user.</param>
        /// <param name="description">The description information of the user.</param>
        /// <param name="profileImageUrl">The profileImageUrl information of the user.</param>
        /// <param name="url">The url information of the user.</param>
        /// <param name="protectedStatus">The protectedStatus information of the user.</param>
        /// <param name="followersCount">The followersCount information of the user.</param>
        /// <param name="profileBackgroundColor">The profileBackgroundColor information of the user.</param>
        /// <param name="profileTextColor">The profileTextColor information of the user.</param>
        /// <param name="profileLinkColor">The profileLinkColor information of the user.</param>
        /// <param name="profileSidebarFillColor">The profileSidebarFillColor information of the user.</param>
        /// <param name="profileSidebarBorderColor">The profileSidebarBorderColor information of the user.</param>
        /// <param name="friendsCount">The friendsCount information of the user.</param>
        /// <param name="createdAt">The createdAt information of the user.</param>
        /// <param name="favouritesCount">The favouritesCount information of the user.</param>
        /// <param name="utcOffset">The utcOffset information of the user.</param>
        /// <param name="timeZone">The timeZone information of the user.</param>
        /// <param name="profileBackgroundImageUrl">The profileBackgroundImageUrl information of the user.</param>
        /// <param name="profileBackgroundTile">The profileBackgroundTile information of the user.</param>
        /// <param name="statusesCount">The statusesCount information of the user.</param>
        /// <param name="notifications">The notifications information of the user.</param>
        /// <param name="verified">The verified information of the user.</param>
        public Friend(string id, string name, string screenName, string location, string description,
                      string profileImageUrl, string url, bool protectedStatus, int followersCount,
                      string profileBackgroundColor, string profileTextColor, string profileLinkColor,
                      string profileSidebarFillColor, string profileSidebarBorderColor, int friendsCount,
                      string createdAt,
                      int favouritesCount, string utcOffset, string timeZone, string profileBackgroundImageUrl,
                      bool profileBackgroundTile, int statusesCount, string notifications, bool verified)
            : base(
                id, name, screenName, location, description, profileImageUrl, url, protectedStatus, followersCount,
                profileBackgroundColor, profileTextColor, profileLinkColor, profileSidebarFillColor,
                profileSidebarBorderColor, friendsCount, createdAt, favouritesCount, utcOffset, timeZone,
                profileBackgroundImageUrl, profileBackgroundTile, statusesCount, notifications, verified)
        {
        }
    }
}