namespace SmartMathLibrary.Interfaces.Web.Twitter
{
    /// <summary>
    /// Interface to implement a Status class.
    /// </summary>
    public interface IStatus
    {
        /// <summary>
        /// Gets or sets the id information.
        /// </summary>
        /// <value>The id information.</value>
        string Id { get; set; }

        /// <summary>
        /// Gets or sets the CreatedAt information.
        /// </summary>
        /// <value>The CreatedAt information.</value>
        string CreatedAt { get; set; }

        /// <summary>
        /// Gets or sets the text information.
        /// </summary>
        /// <value>The text information.</value>
        string Text { get; set; }

        /// <summary>
        /// Compares the current status instance to another one.
        /// </summary>
        /// <param name="compare">The instance to compare.</param>
        /// <returns>True if the values of the current instance and the specified instance are equal otherwise, false.</returns>
        bool CompareTo(Status compare);
    }
}