namespace SmartMathLibrary.Interfaces.Web.Twitter
{
    /// <summary>
    /// Interface to implement a TimelineItem class.
    /// </summary>
    public interface ITimelineItem
    {
        /// <summary>
        /// Gets or sets the user information of the timeline item.
        /// </summary>
        /// <value>The user information of the timeline item.</value>
        User User { get; set; }

        /// <summary>
        /// Gets or sets the status information of the timeline item.
        /// </summary>
        /// <value>The status information of the timeline item.</value>
        Status Status { get; set; }

        /// <summary>
        /// Compares the current user instance to another one.
        /// </summary>
        /// <param name="compare">The instance to compare.</param>
        /// <returns>True if the values of the current instance and the specified instance are equal otherwise, false.</returns>
        bool CompareTo(TimelineItem compare);
    }
}