﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Management
{
    /// <summary>
    /// This class represents an abstract base fro all analyzer classes.
    /// </summary>
    [Serializable]
    public abstract class AbstractAnalyzer
    {
        /// <summary>
        /// The object to analyze.
        /// </summary>
        private Object analyzerObject;

        /// <summary>
        /// Initializes a new instance of the <see cref="AbstractAnalyzer"/> class.
        /// </summary>
        /// <param name="analyzerObject">The object to analyze.</param>
        protected AbstractAnalyzer(Object analyzerObject)
        {
            if (analyzerObject == (object) null)
            {
                throw new ArgumentNullException("analyzerObject");
            }

            this.analyzerObject = analyzerObject;
        }

        /// <summary>
        /// Gets or sets the object to analyze.
        /// </summary>
        /// <value>The object to analyze.</value>
        public Object AnalyzerObject
        {
            get { return analyzerObject; }
            set { analyzerObject = value; }
        }
    }
}