﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace SmartMathLibrary.Management
{
    /// <summary>
    /// This class provides methods to find out the events of a class instance.
    /// </summary>
    [Serializable]
    public class EventAnalyzer : AbstractAnalyzer
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EventAnalyzer"/> class.
        /// </summary>
        /// <param name="analyzerObject">The object to analyze.</param>
        public EventAnalyzer(Object analyzerObject)
            : base(analyzerObject)
        {
        }

        /// <summary>
        /// Analyzes the events of the specified class instance.
        /// </summary>
        /// <returns>The events of the specified class instance.</returns>
        public EventInfo[] AnalyzeEvents()
        {
            Type analyzerType = this.AnalyzerObject.GetType();

            return analyzerType.GetEvents(BindingFlags.NonPublic
                                          | BindingFlags.Instance | BindingFlags.Public);
        }
    }
}