﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Management
{
    /// <summary>
    /// This class provides abstract methods to implement locking and unlocking for a class instance.
    /// </summary>
    [Serializable]
    public abstract class InstanceLocker
    {
        /// <summary>
        /// Locks the current instance.
        /// </summary>
        public abstract void Lock();

        /// <summary>
        /// Unlocks the current instance.
        /// </summary>
        public abstract void Unlock();
    }
}