﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace SmartMathLibrary.Management.Performance
{
    /// <summary>
    /// This exception should be thrown if an information, which was ask for, is not available.
    /// </summary>
    [Serializable]
    public class InformationNotFoundException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InformationNotFoundException"/> class.
        /// </summary>
        public InformationNotFoundException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="InformationNotFoundException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        public InformationNotFoundException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="InformationNotFoundException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public InformationNotFoundException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="InformationNotFoundException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The serialization info.</param>
        /// <param name="streamingContext">The streaming context.</param>
        protected InformationNotFoundException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}