﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace SmartMathLibrary.Management.Pipe
{
    /// <summary>
    /// This exception should be thrown, if a specified pipevalue cannot be found.
    /// </summary>
    [Serializable]
    public class PipeValueNotFoundException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PipeValueNotFoundException"/> class.
        /// </summary>
        public PipeValueNotFoundException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PipeValueNotFoundException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        public PipeValueNotFoundException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PipeValueNotFoundException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public PipeValueNotFoundException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PipeValueNotFoundException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected PipeValueNotFoundException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}