﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace SmartMathLibrary.Management
{
    /// <summary>
    /// This class provides methods to find out the properties of a class instance.
    /// </summary>
    [Serializable]
    public class PropertyAnalyzer : AbstractAnalyzer
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PropertyAnalyzer"/> class.
        /// </summary>
        /// <param name="analyzerObject">The object to analyze.</param>
        public PropertyAnalyzer(Object analyzerObject)
            : base(analyzerObject)
        {
        }

        /// <summary>
        /// Analyzes the properties of the specified class instance.
        /// </summary>
        /// <returns>The properties of the specified class instance.</returns>
        public PropertyInfo[] AnalyzeProperties()
        {
            Type analyzerType = this.AnalyzerObject.GetType();

            return analyzerType.GetProperties(BindingFlags.NonPublic
                                              | BindingFlags.Instance | BindingFlags.Public);
        }
    }
}