﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary
{
    /// <summary>
    /// This class specifics a position in the matrix.  
    /// </summary>
    [Serializable]
    public class MatrixPosition
    {
        /// <summary>
        /// The row- and column index of the current position.
        /// </summary>
        private int row, column;

        /// <summary>
        /// Initializes a new instance of the <see cref="MatrixPosition"/> class.
        /// </summary>
        /// <param name="row">The row position.</param>
        /// <param name="column">The column position.</param>
        public MatrixPosition(int row, int column)
        {
            this.row = row;
            this.column = column;
        }

        /// <summary>
        /// Gets or sets the row position.
        /// </summary>
        /// <value>The row value of the position.</value>
        public int Row
        {
            get { return row; }
            set { row = value; }
        }

        /// <summary>
        /// Gets or sets the column position.
        /// </summary>
        /// <value>The column value of the position.</value>
        public int Column
        {
            get { return column; }
            set { column = value; }
        }
    }
}