﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace SmartMathLibrary
{
    /// <summary>
    /// This exception should be thrown if the dimension of vectors and matrices are not
    /// compatible.
    /// </summary>
    [Serializable]
    public class NotConfortableException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="NotConfortableException"/> class.
        /// </summary>
        public NotConfortableException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotConfortableException"/> class.
        /// </summary>
        /// <param name="message">The error message which the exception includes.</param>
        public NotConfortableException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotConfortableException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public NotConfortableException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="NotConfortableException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The serialization info.</param>
        /// <param name="streamingContext">The streaming context.</param>
        protected NotConfortableException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}