using SmartMathLibrary;

namespace SmartMathLibrary.NumericalIntegration
{
    /// <summary>
    /// Interface to implement a ComplexFinitelyIntegral class.
    /// </summary>
    public interface IComplexFinitelyIntegral
    {
        /// <summary>
        /// Gets or sets the lower value a of the integral.
        /// </summary>
        /// <value>The lower value a of the integral.</value>
        ComplexNumber A { get; set; }

        /// <summary>
        /// Gets or sets the upper value b of the integral.
        /// </summary>
        /// <value>The upper value b of the integral.</value>
        ComplexNumber B { get; set; }

        /// <summary>
        /// Gets or sets the function of the integral.
        /// </summary>
        /// <value>The function of the integral.</value>
        IComplexFunction Function { get; set; }
    }
}