namespace SmartMathLibrary.NumericalIntegration
{
    /// <summary>
    /// Interface to implement an InfinityDoubleIntegral class.
    /// </summary>
    public interface IInfinityDoubleIntegral
    {
        /// <summary>
        /// Gets or sets the bound of the integral which is not infinity.
        /// </summary>
        /// <value>The bound of the integral which is not infinity.</value>
        double Bound { get; set; }

        /// <summary>
        /// Gets or sets the range of the integral.
        /// </summary>
        /// <value>The range of the integral.</value>
        IntegralRange Range { get; set; }

        /// <summary>
        /// Gets or sets the function of the integral.
        /// </summary>
        /// <value>The function of the integral.</value>
        IRealFunction Function { get; set; }
    }
}