﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.NumericalIntegration
{
    /// <summary>
    /// Defines a numerical integration method for 1D integrals.
    /// </summary>
    public enum IntegrationMethod1D
    {
        /// <summary>
        /// Defines the GaussKronrod method.
        /// </summary>
        GaussKronrodMethod = 0,

        /// <summary>
        /// Defines the ExponentialTransform method.
        /// </summary>
        ExponentialTransformMethod = 1,

        /// <summary>
        /// Defines the LeftPoint method.
        /// </summary>
        LeftPointMethod = 2,

        /// <summary>
        /// Defines the MidPoint method.
        /// </summary>
        MidPointMethod = 3,

        /// <summary>
        /// Defines the RightPoint method.
        /// </summary>
        RightPointMethod = 4,

        /// <summary>
        /// Defines the Trapezoid method.
        /// </summary>
        TrapezoidMethod = 5,

        /// <summary>
        /// Defines the Romberg method.
        /// </summary>
        RombergMethod = 6,

        /// <summary>
        /// Defines the Simpson method.
        /// </summary>
        SimpsonMethod = 7
    }
}
