using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace SmartMathLibrary
{
    /// <summary>
    /// The class should be thrown if a rank of a polynomial does not exist.
    /// </summary>
    [Serializable]
    public class PolynomialRankNotFoundException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PolynomialRankNotFoundException"/> class.
        /// </summary>
        public PolynomialRankNotFoundException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PolynomialRankNotFoundException"/> class.
        /// </summary>
        /// <param name="message">The message which should be thrown.</param>
        public PolynomialRankNotFoundException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PolynomialRankNotFoundException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public PolynomialRankNotFoundException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PolynomialRankNotFoundException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected PolynomialRankNotFoundException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}