﻿using System;

namespace SmartMathLibrary.QuadPack
{
    /// <summary>
    /// This class defines needed constants for QuadPack.
    /// </summary>
    [Serializable]
    public static class QuadPackConstants
    {
        /// <summary>
        /// QuadPack constants for cosine.
        /// </summary>
        public const int COSINE = 1;

        /// <summary>
        /// QuadPack constants for false.
        /// </summary>
        public const int FALSE = 0;

        /// <summary>
        /// QuadPack constants for the maximum iterations for an integration.
        /// </summary>
        public const int LIMIT = 500;

        /// <summary>
        /// QuadPack MAXP1 constants.
        /// </summary>
        public const int MAXP1 = 21;

        /// <summary>
        /// QuadPack NMAC constants.
        /// </summary>
        public const int NMAC = 27;

        /// <summary>
        /// QuadPack P constants.
        /// </summary>
        public const double P = 0.9;

        /// <summary>
        /// QuadPack constants for sine.
        /// </summary>
        public const int SINE = 2;

        /// <summary>
        /// QuadPack constants for true.
        /// </summary>
        public const int TRUE = 1;
    }
}