﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace SmartMathLibrary
{
    /// <summary>
    /// This class represents an exception for mathematical progressions.
    /// </summary>
    [Serializable]
    public class SequenceException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SequenceException"/> class.
        /// </summary>
        public SequenceException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SequenceException"/> class.
        /// </summary>
        /// <param name="message">The error message.</param>
        public SequenceException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SequenceException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public SequenceException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SequenceException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected SequenceException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}