﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Simulation.LogicalGate
{
    /// <summary>
    /// This function pointer fetches the input information for an input channel of a gate. 
    /// </summary>
    public delegate Byte ByteGrabber();

    /// <summary>
    /// This class represents an abstract layer for all input gate modules.
    /// </summary>
    [Serializable]
    public abstract class AbstractInputGateModule
    {
        /// <summary>
        /// Gets the logical result, which is defined by the gate and the specified input values.
        /// </summary>
        /// <returns>The result of the logical gate.</returns>
        public abstract Byte GetResult();
    }
}