﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace SmartMathLibrary.Space
{
    /// <summary>
    /// This class provides methods to find out the fields of a class instance.
    /// </summary>
    [Serializable]
    public class FieldAnalyzer : AbstractAnalyzer
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FieldAnalyzer"/> class.
        /// </summary>
        /// <param name="analyzerObject">The object to analyze.</param>
        public FieldAnalyzer(Object analyzerObject)
            : base(analyzerObject)
        {
        }

        /// <summary>
        /// Analyzes the fields of the specified class instance.
        /// </summary>
        /// <returns>The fields of the specified class instance.</returns>
        public FieldInfo[] AnalyzeFields()
        {
            Type analyzerType = this.AnalyzerObject.GetType();

            return analyzerType.GetFields(BindingFlags.NonPublic
                                          | BindingFlags.Instance | BindingFlags.Public);
        }
    }
}