﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Space
{
    /// <summary>
    /// This class represents a specialisation of a space client provider. It can only connect 
    /// to space containers at the local host.
    /// </summary>
    public class LocalSpaceClientProvider : SpaceClientProvider
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LocalSpaceClientProvider"/> class.
        /// </summary>
        /// <param name="name">The publish name of the object space container.</param>
        /// <param name="port">The publish port of the object space container.</param>
        public LocalSpaceClientProvider(string name, int port)
            : base("localhost", name, port)
        {
        }
    }
}