﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SmartMathLibrary.Space.CoreTypes;

namespace SmartMathLibrary.Space.QueryEngine
{
    /// <summary>
    /// Defines the available data types for the space.
    /// </summary>
    public enum SpaceTypes
    {
        /// <summary>
        /// Defines <see cref="SpaceDouble"/>.
        /// </summary>
        Double,

        /// <summary>
        /// Defines <see cref="SpaceInteger"/>.
        /// </summary>
        Integer,

        /// <summary>
        /// Defines <see cref="SpaceIntegral"/>.
        /// </summary>
        Integral,

        /// <summary>
        /// Defines <see cref="SpaceMatrix"/>.
        /// </summary>
        Matrix,

        /// <summary>
        /// Defines <see cref="SpaceObject"/>.
        /// </summary>
        Object,

        /// <summary>
        /// Defines <see cref="SpacePoint"/>.
        /// </summary>
        Point,

        /// <summary>
        /// Defines <see cref="SpacePoint3D"/>.
        /// </summary>
        Point3D,

        /// <summary>
        /// Defines <see cref="SpaceString"/>.
        /// </summary>
        String,

        /// <summary>
        /// Defines <see cref="SpaceTable"/>.
        /// </summary>
        Table,

        /// <summary>
        /// Defines <see cref="SpaceVector"/>.
        /// </summary>
        Vector
    }
}