﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace SmartMathLibrary.Space
{
    /// <summary>
    /// This exception should be thrown if the space object for the request is locked.
    /// </summary>
    [Serializable]
    public class SpaceIDAlreadyExistsException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SpaceIDAlreadyExistsException"/> class.
        /// </summary>
        public SpaceIDAlreadyExistsException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SpaceIDAlreadyExistsException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        public SpaceIDAlreadyExistsException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SpaceIDAlreadyExistsException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public SpaceIDAlreadyExistsException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SpaceIDAlreadyExistsException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The serialization info.</param>
        /// <param name="streamingContext">The streaming context.</param>
        public SpaceIDAlreadyExistsException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}