﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Statistics
{
    /// <summary>
    /// This class represents a linear trend function.
    /// </summary>
    [Serializable]
    public class LinearTrendFunction : LinearFunction
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LinearTrendFunction"/> class.
        /// </summary>
        /// <param name="m">The slope of the function.</param>
        /// <param name="n">The translation constant of the function.</param>
        public LinearTrendFunction(double m, double n)
            : base(m, n)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="LinearTrendFunction"/> class.
        /// </summary>
        /// <param name="function">The trendfunction to clone.</param>
        public LinearTrendFunction(LinearTrendFunction function)
            : base(function)
        {
        }
    }
}