﻿using System;

namespace SmartMathLibrary.Storage
{
    /// <summary>
    /// Supports methods to add a point to a storage. 
    /// </summary>
    public interface IPointStorage
    {
        /// <summary>
        /// This method adds a new point to the current storage. If the maximum capacity of the 
        /// storage is exceeded, it will automatically overwrite the smallest point of the storage.
        /// </summary>
        /// <param name="item">The point item, which should be added.</param>
        void AddPoint(Storage.StoragePoint item);
    }
}