﻿using System;

namespace SmartMathLibrary.Storage
{
    /// <summary>
    /// This exception should be thrown, if there is not permission to add the specified point.
    /// </summary>
    public interface IPointStorageAddingPermission
    {
        /// <summary>
        /// This method checks the permission to add a new point to a storage.
        /// </summary>
        /// <param name="item">The position item, which should be checked.</param>
        /// <returns>True, if the storage data allows the adding of the point otherwise, false.</returns>
        bool CheckAddingPermission(StoragePoint item);
    }
}