﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace SmartMathLibrary.Storage
{
    /// <summary>
    /// This exception should be thrown if someone tries to add a point to a storage, while the lockstatus
    /// is set to locked.
    /// </summary>
    [Serializable]
    public class StorageLockedException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="StorageLockedException"/> class.
        /// </summary>
        public StorageLockedException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="StorageLockedException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        public StorageLockedException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="StorageLockedException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public StorageLockedException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="StorageLockedException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected StorageLockedException(SerializationInfo serializationInfo, StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}