﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace SmartMathLibrary.Storage
{
    /// <summary>
    /// This exception should be thrown if the point, which someone tries to add, has no permission to be
    /// added to the storage.
    /// </summary>
    [Serializable]
    public class StoragePointAddingPremissionFailedException : Exception
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="StoragePointAddingPremissionFailedException"/> class.
        /// </summary>
        public StoragePointAddingPremissionFailedException()
            : base()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="StoragePointAddingPremissionFailedException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        public StoragePointAddingPremissionFailedException(String message)
            : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="StoragePointAddingPremissionFailedException"/> class.
        /// </summary>
        /// <param name="message">The message of the exception.</param>
        /// <param name="exception">The inner exception.</param>
        public StoragePointAddingPremissionFailedException(String message, Exception exception)
            : base(message, exception)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="StoragePointAddingPremissionFailedException"/> class.
        /// </summary>
        /// <param name="serializationInfo">The internal serializationinfo.</param>
        /// <param name="streamingContext">The internal streamingcontext.</param>
        protected StoragePointAddingPremissionFailedException(SerializationInfo serializationInfo,
                                                              StreamingContext streamingContext)
            : base(serializationInfo, streamingContext)
        {
        }
    }
}