﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SmartMathLibrary.Storage
{
    /// <summary>
    /// Ths class represents a definition for a storagedata selection.
    /// </summary>
    [Serializable]
    public class StorageSelectionDefinition
    {
        /// <summary>
        /// Defines the minimum x value of the selection.
        /// </summary>
        private double minX;

        /// <summary>
        /// Defines the maximum x value of the selection.
        /// </summary>
        private double maxX;

        /// <summary>
        /// Initializes a new instance of the <see cref="StorageSelectionDefinition"/> class.
        /// </summary>
        public StorageSelectionDefinition()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="StorageSelectionDefinition"/> class.
        /// </summary>
        /// <param name="minX">The minimum x value of the selectiondefinition.</param>
        /// <param name="maxX">The maximum x value of the selectiondefinition.</param>
        public StorageSelectionDefinition(double minX, double maxX)
        {
            this.minX = minX;
            this.maxX = maxX;
        }

        /// <summary>
        /// Gets or sets the maximum x value of the selectiondefinition.
        /// </summary>
        /// <value>The maximum x value of the selectiondefinition.</value>
        public double MaxX
        {
            get { return maxX; }
            set { maxX = value; }
        }

        /// <summary>
        /// Gets or sets the minimum x value of the selectiondefinition.
        /// </summary>
        /// <value>The minimum x value of the selectiondefinition.</value>
        public double MinX
        {
            get { return minX; }
            set { minX = value; }
        }
    }
}